ActionDispatch ってなんだろう

# 目的

* ActionDispatch がなにをするものなか伝える

# 対象

* Rails なんとなくわかる人を中心にしつつも Railsをしらない人

# おさらい

## Rackオブジェクト

* call メソッドをもつ
* 引数 Hash
* 戻り値 [Fixnum, Hash, Enumerable]
env を渡すと ステータスコード レスポンスヘッダ レスポンスボディ

## Rackミドルウェア

* Rackオブジェクトである
* コンストラクタでラックオブジェクトをうけとる

図示する

## Rails のアーキテクチャ

* ActiveSupport
* Railties
* ActionPack
  * ActionDispatch
  * ActionController
  * AbstractController
* ActionView
* ActiveModel
* ActionMailer
* ActiveRecord


# Railsアプリケーションの全体像

## Rails.application :: Rails::Application

大きな Rackアプリケーション

## その中身は

たくさんのミドルウェアに

```
> Rails.application.class

```
```
Rails.application.class.ancestors
=> [Hoge::Application,
 Rails::Application,
 Rails::Engine,
 Rails::Railtie,
 Rails::Initializable,
 Object,
 ActiveSupport::Dependencies::Loadable,
 PP::ObjectMixin,
 JSON::Ext::Generator::GeneratorMethods::Object,
 Kernel,
 BasicObject]
```

```
> show-method Rails::Application#call
def call(env)
  env["ORIGINAL_FULLPATH"] = build_original_fullpath(env)
  env["ORIGINAL_SCRIPT_NAME"] = env["SCRIPT_NAME"]
  super(env)
end
```

```
> show-method Rails::Engine#call
def call(env)
  env.merge!(env_config)
  if env['SCRIPT_NAME']
    env.merge! "ROUTES_#{routes.object_id}_SCRIPT_NAME" => env['SCRIPT_NAME'].dup
  end
  app.call(env)
end
```

```
> Rails.application.app
 @app=
  #<ActionDispatch::Static:0x007fe97db880d0
   @app=
    #<Rack::Lock:0x007fe97db88148
     @app=
      #<ActiveSupport::Cache::Strategy::LocalCache::Middleware:0x007fe97e35cc70
       @app=
        #<Rack::Runtime:0x007fe97db88198
         @app=
          #<Rack::MethodOverride:0x007fe97db881c0
```

```
> Rails.application.middleware
=> #<ActionDispatch::MiddlewareStack:0x007fe97bcbaf68
 @middlewares=
  [Rack::Sendfile,
   ActionDispatch::Static,
   Rack::Lock,
   #<ActiveSupport::Cache::Strategy::LocalCache::Middleware:0x007fe97e35cc70>,
   Rack::Runtime,
   Rack::MethodOverride,
   ActionDispatch::RequestId,
   Rails::Rack::Logger,
   ActionDispatch::ShowExceptions,
   ActionDispatch::DebugExceptions,
   ActionDispatch::RemoteIp,
   ActionDispatch::Reloader,
   ActionDispatch::Callbacks,
   ActiveRecord::Migration::CheckPending,
   ActiveRecord::ConnectionAdapters::ConnectionManagement,
   ActiveRecord::QueryCache,
   ActionDispatch::Cookies,
   ActionDispatch::Session::CookieStore,
   ActionDispatch::Flash,
   ActionDispatch::ParamsParser,
   Rack::Head,
   Rack::ConditionalGet,
   Rack::ETag]>
```

```
> Rails.application.endpoint
=> #<ActionDispatch::Routing::RouteSet:0x007fe97dad1830>
```

```
> Rails.application.routes
=> #<ActionDispatch::Routing::RouteSet:0x007fe97dad1830>
```

RouteSet の話はまた後で。

# ActionDispatch

## ActionDispatch::ROuting

## ActionDispatch::Journey

実装にルーティングの機能を提供している部分。複雑。

```
> Rails.application.routes.set
=> #<ActionDispatch::Journey::Routes:0x007fe97db62d58
```

```
> Rails.application.routes.routes
=> #<ActionDispatch::Journey::Routes:0x007fe97db62d58
```


## ActionDispatch::Routing

## ActionDispatch::HTTP

## ActionDispatch::Middleware

## ActionDispatch::Request

## ActionDIspatch::Testing

# Routing

## ActionDIspatch::Routing::RouteSet

ルータへのフロントエンド add_route によってルーティングを追加できたり
draw メソッドでルーティングを記述するための DSL かかける。

DSLは ActionDispatch::Routing::Mapper で提供されている

https://github.com/rails/rails/blob/4-1-stable/actionpack/lib/action_dispatch/routing/mapper.rb

## ActionDispatch::Routing::Mapper

resource, get など config/rotuse.rb に記述するものが提供されてる。

どのメソッドも最終的には add_route が呼ばれるはず。

# まとめ

* ActionDispatch は Controller への橋渡しをする
  * ルーティングを提供
* 関連する主なファイルは config/routes.rb
* Rails::Application のコアになる (ActionDispatch::Routing::RouteSet
* `config/rotuse.rb` の語彙は ActionDispatch::Routing::Mapper が提供する
* ルーティングの基盤を支えているのが Journey (Rails 3.2から)
